uniform lowp sampler2D texture_sampler;
varying mediump vec2 var_texcoord0;
uniform lowp vec4 tint;
uniform lowp vec4 brightness;
uniform lowp vec4 contrast;

vec4 get_contrast(vec4 colors, float contrast)
{
    colors.rgb /= colors.a;
    colors.rgb = ((colors.rgb - 0.5) * max(contrast + 1.0, 0.0)) + 0.5;
    colors.rgb *= colors.a;
    return colors;
}


vec4 get_brightness(vec4 colors, float brightness)
{
    colors.rgb /= colors.a;
    colors.rgb += brightness;
    colors.rgb *= colors.a;
    return colors;
}

void main()
{
    vec2 res = vec2(1.0, 1.0); 
    vec2 uv = var_texcoord0.xy / res.xy;
    vec4 colors = texture2D(texture_sampler, uv);
    lowp vec4 tint_pm = vec4(tint.xyz * tint.w, tint.w);
    gl_FragColor = get_brightness(get_contrast(colors, contrast.x),brightness.x) * tint_pm;
}